syntax = "proto2";
package buffers.resources;

import "options.proto";

message Font {
  message Glyph {
    optional uint32 character = 1;
    
    // Rectangle in the sprite font texture given by `image`.
    optional uint32 x = 2;
    optional uint32 y = 3; 
    optional uint32 width = 4 [(gmx) = "w"];
    optional uint32 height = 5 [(gmx) = "h"];
    
    // Kerning offsets. Round on .5 after summing.
    optional double origin = 6 [(gmx) = "offset"]; 
    optional double baseline = 7;
    optional double advance = 8 [(gmx) = "shift"];
  }

  message Range {
    optional int32 min = 1 [(gmx) = "GMX_SPLIT/0"];
    optional int32 max = 2 [(gmx) = "GMX_SPLIT/1"];
  }

  optional int32 id = 2 [(gmx) = "GMX_DEPRECATED"];

  optional string font_name = 3 [(gmx) = "name"];
  optional int32 size = 4;
  optional bool bold = 5;
  optional bool italic = 6;

  repeated Range ranges = 7 [(gmx) = "ranges/range0"];
  repeated Glyph glyphs = 8 [(gmx) = "glyphs/glyph"];
  
  optional bool renderhq = 10;
  optional uint32 charset = 11;
  optional uint32 antialias = 12 [(gmx) = "aa"];
  optional bool include_ttf = 13 [(gmx) = "includeTTF"];
  optional string ttf_file = 14 [(gmx) = "TTFName"]; 
  optional int32 texture_group = 15 [(gmx) = "texgroups/texgroup0"];
  optional string image = 16;
}
